﻿Public Class Form1
    Dim SP As SpectraPLUS_SCAutomationLib.ISpectraPLUS_SC


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        TestStatus.Text = ""
    End Sub

    Private Sub OpenAnalyzer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenAnalyzer.Click
        If SP Is Nothing Then
            'Launch the spectrum analyzer
            SP = New SpectraPLUS_SCAutomationLib.SpectraPLUS_SCClass
        End If

        If SP Is Nothing Then
            MsgBox("Failure Opening SpectraPLUS-SC")
        End If

    End Sub

    Private Sub SetupAnalyzer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SetupAnalyzer.Click
        If SP Is Nothing Then
            MsgBox("SpectraPLUS-SC is not Open")
        Else
            ' Configure the settings
            'Note: Use the Load Configuration command to easily setup the analyzer
            'Example:  SP.LoadConfig("C:\SpectraPLUS_SC\Config\test1.cfg")

            SP.SetMode(0)  ' Real time mode
            SP.SetNumChannels(1)
            SP.SetSamplingRate(44100)
            SP.SetSamplingPrecision(16)

        End If

    End Sub

    Private Sub RunTest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RunTest.Click
        If SP Is Nothing Then
            MsgBox("SpectraPLUS-SC is not Open")
        Else
            SP.Run()
            TestTimer.Interval = 250
            TestTimer.Enabled = True
        End If

    End Sub

    Private Sub StopTest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StopTest.Click
        TestTimer.Enabled = False

        If SP Is Nothing Then
            MsgBox("SpectraPLUS-SC is not Open")
        Else
            SP.Stop()
            TestStatus.Text = ""
        End If

    End Sub

    Private Sub TestTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TestTimer.Tick
        TestSignal()
    End Sub

    Private Sub TestSignal()
        If SP Is Nothing Then

        Else
            ' Test the signal - this is where you implement your pass/fail 
            ' teset logic.  You can read amplitudes, frequencies, Total 
            ' power, THD, etc.  In this example we will find the peak frequency 
            ' and amplitude within a frequency span by reading the spectral data 
            ' values and searching through the array for the max value.
            ' This is easier done using SP.GetPeakAmplitudeNthSpan() but 
            ' this example demonstrates the use of arrays.

            Dim channel As Integer
            Dim startHz As Single
            Dim stopHz As Single

            channel = 0   ' left channel
            startHz = 500
            stopHz = 2000

            Dim FreqArray As Array
            Dim AmpArray As Array

            ' Read the arrays of frequency and amplitude data values
            SP.GetSpectrumInSpan(channel, startHz, stopHz, FreqArray, AmpArray)

            Dim PeakAmp As Single
            PeakAmp = -999

            Dim PeakAmpIndex As Integer
            PeakAmpIndex = 0

            ' Search the array of amplitude values for the peak value
            Dim i As Integer
            For i = 1 To UBound(AmpArray)
                If AmpArray(i) > PeakAmp Then
                    PeakAmp = AmpArray(i)   ' store the peak value
                    PeakAmpIndex = i      ' store the index so we can find the frequency
                End If
            Next i

            Dim PeakFreq As Single
            PeakFreq = FreqArray(PeakAmpIndex)

            '  Validate the peak signal values (change this logic as needed)
            If (PeakAmp > -40 And PeakFreq > 1000 And PeakFreq < 1500) Then
                TestStatus.Text = "PASS"
                TestStatus.ForeColor = Color.Green
            Else
                TestStatus.Text = "FAIL"
                TestStatus.ForeColor = Color.Red
            End If
        End If
    End Sub
End Class
